#
#
# $Id: bbsinit.rb,v 1.8 2004/10/04 09:38:54 Yuukis Exp $
#
#

module BBSMenu
	require 'nkf'

	MenuFile = "#{CFG::SYS.root}bbsmenu.html"
	StdBoards = [] # ['http://pc5.2ch.net/unix/', 'http://pc5.2ch.net/linux/'...]
	Servers = {}  # {'unix'=>'pc.2ch.net', 'tech'=>'pc2.2ch.net'}
	IGNORE = ['2ch', '2ch', '2chӥ塼']  # ɸİʳ̵

	Net2ch.set_agent(CFG::SYS.monazilla)
	Net2ch.set_proxy(CFG::Proxy.get_addr, CFG::Proxy.get_port,
		CFG::Proxy.post_addr, CFG::Proxy.post_port)

	@@favorites = []  # ['Unix'=>'http://pc.2ch.net/unix/', 'ץ'=>'http://pc2.2ch.net/tech/']

	def BBSMenu.get
		result, response = Net2ch.get_keep(CFG::Net.bbsmenu_url, MenuFile)
		return([result, response.code])
	end

	def BBSMenu.parse
		get unless File.exist?(MenuFile)
		x = NKF.nkf('-exS', IO.readlines(MenuFile).join)
		x.gsub!(/.*2ch<\/A>/m, '')
		IGNORE.each {|y| x.gsub!(/.*#{y}.*/, '') }
		x.gsub!(/pink̩.*/m, "pink̩</A>\n")
		x.gsub!(/<br>/i, '')
		x.gsub!(/<\/B>.*/, '')
		x.gsub!(/^\n/, '')

		bbsmenu = []
		@@favorites = []

		x.each {|line|
			if line =~ /^<B>/
				bbsmenu << [line.sub(/<B>/, '').chomp, 'C-']
			else
				line.sub!(/<a href=http:\/\/(.*?)\/(.*?)\/>(.*)<\/a>/i){
					server = $1; dir = $2; name = $3; url = "http://#{$1}/#{$2}/"
					bbsmenu << [name, url]
					Servers[dir]= server
					StdBoards << url
					if i = CFG::Identity.myfavorites.index(dir)
						@@favorites << [i, name, url]
					end
				}
			end
		}

		if @@favorites != []
			@@favorites.sort!.each {|i| i.shift }
			@@favorites.reverse_each {|x| bbsmenu.unshift(x) }
		end

		bbsmenu.unshift(['Favorites', 'C-'])
		return(bbsmenu)
	end

	def BBSMenu.init ; parse ; end
	# ؤܤʽ alias_method(:parse, :init) ʤ꤯Τˡ

	def BBSMenu.favorite
		@@favorites
	end

	def BBSMenu.stdboard?(board)
		StdBoards.include?(board)
	end
end
